#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# QuickRecon v0.3
# Copyright (C) 2011 Filip Szymański <f.szymanski@hotmail.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
# -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
# Please note that this tool was created and published for educational purposes only.
#
# -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-


import httplib
import random
import re
import socket
import sys
import urllib2

try:
	from cStringIO import StringIO
except:
	from StringIO import StringIO

try:
	import sip
	sip.setapi("QVariant", 2)
except ImportError:
	print "Please install \'SIP\' from http://www.riverbankcomputing.co.uk/software/sip/."
	sys.exit(2)

try:
	from PyQt4.QtCore import *
	from PyQt4.QtGui import *
except ImportError:
	print "Please install \'PyQt4\' from http://www.riverbankcomputing.co.uk/software/pyqt/."
	sys.exit(2)

import img_rc

database = [
			"adm", "admin", "admins", "agent", "aix", "alerts", "av", "antivirus", "app", "apps", "appserver",
			"archive", "as400", "auto", "backup", "banking", "bbdd", "bbs", "bea", "beta", "blog", "catalog",
			"cgi", "channel", "channels", "chat", "cisco", "client", "clients", "club", "cluster", "clusters",
			"code", "commerce",	"community", "compaq", "console", "consumer", "contact", "contracts", "corporate",
			"ceo", "cso", "cust", "customer", "data", "bd", "db2", "default", "demo", "design",	"desktop", "dev",
			"develop", "developer", "device", "dial", "digital", "dir",	"directory", "disc", "discovery", "disk",
			"dns", "dns1", "dns2", "dns3", "docs", "documents", "domain", "domains", "dominoweb", "download",
			"downloads", "ecommerce", "e-commerce", "edi", "edu", "education", "email", "enable", "engine",
			"engineer",	"enterprise", "event", "events", "example", "exchange", "extern", "external", "extranet",
			"fax", "field", "finance", "firewall", "forum", "forums", "fsp", "ftp",	"ftp2", "fw", "fw1", "gallery",
			"galleries", "games", "gateway", "gopher", "guest",	"gw", "hello", "helloworld", "help", "helpdesk",
			"helponline", "hp", "ibm", "ibmdb",	"ids", "ILMI", "images", "imap", "imap4", "img", "imgs", "info",
			"intern", "internal", "intranet", "invalid", "iphone", "ipsec", "irc", "ircserver", "jobs", "ldap",
			"link",	"linux", "lists", "listserver", "local", "localhost", "log", "logs", "login", "lotus", "mail",
			"mailboxes", "mailhost", "management", "manage", "manager", "map", "maps", "marketing", "device",
			"media", "member", "members", "messenger", "mngt", "mobile", "monitor", "multimedia", "music", "names",
			"net", "netdata", "netstats", "network", "news", "nms", "nntp", "ns", "ns1", "ns2", "ns3", "ntp",
			"online", "openview", "oracle",	"outlook", "page", "pages", "partner", "partners", "pda", "personal",
			"ph", "pictures", "pix", "pop", "pop3", "portal", "press", "print", "printer", "private", "project",
			"projects", "proxy", "public", "ra", "radio", "raptor", "ras", "read", "register", "remote", "report",
			"reports", "root", "router", "rwhois", "sac", "schedules", "scotty", "search", "secret", "secure",
			"security", "seri", "serv", "serv2", "server", "service", "services", "shop", "shopping", "site", "sms",
			"smtp", "smtphost", "snmp", "snmpd", "snort", "solaris", "solutions", "support", "source", "sql", "ssl",
			"stats", "store", "stream", "streaming", "sun", "support", "switch", "sysback", "system", "tech",
			"terminal", "test", "testing", "testing123", "time", "tivoli", "training", "transfers",	"uddi",
			"update", "upload", "uploads", "video", "vpn", "w1", "w2", "w3", "wais", "wap",	"web", "webdocs",
			"weblib", "weblogic", "webmail", "webserver", "webservices", "websphere", "whois", "wireless", "work",
			"world", "write", "ws", "ws1", "ws2", "ws3", "www1", "www2", "www3", "error", "cpanel", "my"
				]

agents = [
			"Mozilla/5.0 (Windows NT 6.1; rv:2.0.1) Gecko/20100101 Firefox/4.0.1",
			"Opera/9.80 (Windows NT 5.1; U; pl) Presto/2.8.131 Version/11.10",
			"Links (2.3pre1; Linux 2.6.38-8-generic i686; 160x40)",
			"Mozilla/5.0 (X11; Linux i686; rv:2.0.1) Gecko/20100101 Firefox/4.0.1",
			"Lynx/2.8.8dev.7 libwww-FM/2.14 SSL-MM/1.4.1 GNUTLS/2.8.6",
			"Mozilla/5.0 (Windows NT 6.0) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/11.0.696.68 Safari/534.24",
			"Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; Trident/5.0)",
			"Mozilla/5.0 (compatible; Konqueror/4.6; Linux) KHTML/4.6.0 (like Gecko) SUSE",
			"Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.9.2.10) Gecko/20101005 Fedora/3.6.10-1.fc14 Firefox/3.6.10",
			"Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.1)"
			]

xfn = [
			"friend", "acquaintance", "contact", "met", "co-worker", "colleague",
			"co-resident", "neighbor", "child", "parent", "sibling", "spouse",
			"kin", "muse", "crush", "date", "sweetheart", "me"
			]

license = (
			"This program is free software: you can redistribute it and/or modify "
			"it under the terms of the GNU General Public License as published by "
			"the Free Software Foundation, either version 3 of the License, or "
			"(at your option) any later version.\n\n"
			"This program is distributed in the hope that it will be useful, "
			"but WITHOUT ANY WARRANTY; without even the implied warranty of "
			"MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the "
			"GNU General Public License for more details.\n\n"
			"You should have received a copy of the GNU General Public License "
			"along with this program. If not, see <http://www.gnu.org/licenses/>."
			)

info = (
		"QuickRecon ver. 0.3\n"
		"A simple information gathering utility, based on Qt4 toolkit.\n"
		"Copyright (C) 2011 Filip Szymański\n"
		"f.szymanski@hotmail.com\n"
		"http://code.google.com/p/quickrecon/"
		)


class QuickRecon(QMainWindow):

	def __init__(self, parent=None):
		super(QuickRecon, self).__init__(parent)

		self.buffer = StringIO()

		self.setWindowIcon(QIcon(":/icon.png"))
		self.setWindowTitle("QuickRecon v0.3")
		self.setFixedSize(500, 520)

		self.readSettings()

		self.mainWidget = QWidget()
		self.setCentralWidget(self.mainWidget)

		self.saveAction = QAction("Save as", self, shortcut="Ctrl+S",
									statusTip="Save the results to a file.", triggered=self.saveAs)
		self.exitAction = QAction("Exit", self, shortcut="Ctrl+Q",
									statusTip="Exit the application.", triggered=self.exitApplication)
		self.xfnAction = QAction("XFN", self, shortcut="Ctrl+X",
									statusTip="XFN quick reference.", triggered=self.xfnReference)
		self.aboutAction = QAction("About", self, shortcut="Ctrl+A",
									statusTip="About the QuickRecon.", triggered=self.about)

		self.fileMenu = self.menuBar().addMenu("File")
		self.fileMenu.addAction(self.saveAction)
		self.fileMenu.addSeparator()
		self.fileMenu.addAction(self.exitAction)

		self.helpMenu = self.menuBar().addMenu("Help")
		self.helpMenu.addAction(self.xfnAction)
		self.helpMenu.addAction(self.aboutAction)

		self.statusBar()

		self.pushButton1 = QPushButton("Browse ...")
		self.pushButton2 = QPushButton("Exit")
		self.pushButton3 = QPushButton("Run")

		self.checkBox1 = QCheckBox("Google")
		self.checkBox1.setChecked(True)
		self.checkBox2 = QCheckBox("Google Groups")
		self.checkBox3 = QCheckBox("Bing")

		self.lineEdit1 = QLineEdit()
		self.lineEdit2 = QLineEdit()
		self.lineEdit3 = QLineEdit()
		self.lineEdit4 = QLineEdit()
		self.lineEdit5 = QLineEdit()

		self.textEdit = QTextEdit()
		self.textEdit.setReadOnly(True)
		self.textEdit.setLineWrapMode(QTextEdit.NoWrap)

		self.spinBox = QSpinBox()
		self.spinBox.setRange(50, 500)
		self.spinBox.setSingleStep(50)

		self.label1 = QLabel("Domain <i>( example.com )</i>")
		self.label2 = QLabel("External subdomain dictionary <i>( optional )</i>")
		self.label3 = QLabel("Domain <i>( example.com )</i>")
		self.label4 = QLabel("Blog <i>( http://blog.example.com/ )</i>")
		self.label5 = QLabel("Domain <i>( example.com )</i>")

		self.tabWidget = QTabWidget()
		self.tab1 = QWidget()
		self.tabWidget.addTab(self.tab1, "Subdomains")
		self.tab2 = QWidget()
		self.tabWidget.addTab(self.tab2, "Emails")
		self.tab3 = QWidget()
		self.tabWidget.addTab(self.tab3, "Relationships")
		self.tab4 = QWidget()
		self.tabWidget.addTab(self.tab4, "Zone transfer")

		self.groupBox1 = QGroupBox("Web search engine")
		self.groupBox2 = QGroupBox("Search limit")
		self.groupBox3 = QGroupBox("Output")

		# Tab1 /
		self.hBoxLayout1 = QHBoxLayout()
		self.hBoxLayout1.addWidget(self.lineEdit1)
		self.hBoxLayout1.addSpacing(220)

		self.hBoxLayout2 = QHBoxLayout()
		self.hBoxLayout2.addWidget(self.lineEdit2)
		self.hBoxLayout2.addWidget(self.pushButton1)

		self.vBoxLayout1 = QVBoxLayout()
		self.vBoxLayout1.addWidget(self.label1)
		self.vBoxLayout1.addLayout(self.hBoxLayout1)
		self.vBoxLayout1.addWidget(self.label2)
		self.vBoxLayout1.addLayout(self.hBoxLayout2)
		self.vBoxLayout1.addStretch(1)
		self.tab1.setLayout(self.vBoxLayout1)			# /

		# Tab2 /
		self.hBoxLayout3 = QHBoxLayout()
		self.hBoxLayout3.addWidget(self.lineEdit3)
		self.hBoxLayout3.addSpacing(220)

		self.hBoxLayout4 = QHBoxLayout()
		self.hBoxLayout4.addWidget(self.checkBox1)
		self.hBoxLayout4.addWidget(self.checkBox2)
		self.hBoxLayout4.addWidget(self.checkBox3)
		self.groupBox1.setLayout(self.hBoxLayout4)

		self.vBoxLayout2 = QVBoxLayout()
		self.vBoxLayout2.addWidget(self.spinBox)
		self.groupBox2.setLayout(self.vBoxLayout2)

		self.hBoxLayout5 = QHBoxLayout()
		self.hBoxLayout5.addWidget(self.groupBox1)
		self.hBoxLayout5.addSpacing(20)
		self.hBoxLayout5.addWidget(self.groupBox2)
		self.hBoxLayout5.addSpacing(140)

		self.vBoxLayout3 = QVBoxLayout()
		self.vBoxLayout3.addWidget(self.label3)
		self.vBoxLayout3.addLayout(self.hBoxLayout3)
		self.vBoxLayout3.addLayout(self.hBoxLayout5)
		self.vBoxLayout3.addStretch(1)
		self.tab2.setLayout(self.vBoxLayout3)			# /

		# Tab3 /
		self.hBoxLayout6 = QHBoxLayout()
		self.hBoxLayout6.addWidget(self.lineEdit4)
		self.hBoxLayout6.addSpacing(220)

		self.vBoxLayout4 = QVBoxLayout()
		self.vBoxLayout4.addWidget(self.label4)
		self.vBoxLayout4.addLayout(self.hBoxLayout6)
		self.vBoxLayout4.addStretch(1)
		self.tab3.setLayout(self.vBoxLayout4)			# /

		# Tab4 /
		self.hBoxLayout7 = QHBoxLayout()
		self.hBoxLayout7.addWidget(self.lineEdit5)
		self.hBoxLayout7.addSpacing(220)

		self.vBoxLayout5 = QVBoxLayout()
		self.vBoxLayout5.addWidget(self.label5)
		self.vBoxLayout5.addLayout(self.hBoxLayout7)
		self.vBoxLayout5.addStretch(1)
		self.tab4.setLayout(self.vBoxLayout5)			# /

		self.vBoxLayout6 = QVBoxLayout()
		self.vBoxLayout6.addWidget(self.textEdit)
		self.groupBox3.setLayout(self.vBoxLayout6)

		self.hBoxLayout8 = QHBoxLayout()
		self.hBoxLayout8.addWidget(self.pushButton2)
		self.hBoxLayout8.addSpacing(260)
		self.hBoxLayout8.addWidget(self.pushButton3)

		self.mainLayout = QGridLayout()
		self.mainLayout.addWidget(self.tabWidget, 0, 0)
		self.mainLayout.addWidget(self.groupBox3, 1, 0)
		self.mainLayout.setRowStretch(1, 1)
		self.mainLayout.addLayout(self.hBoxLayout8, 2, 0)
		self.mainWidget.setLayout(self.mainLayout)

		self.connect(self.pushButton1, SIGNAL("clicked()"), self.selectFile)
		self.connect(self.pushButton2, SIGNAL("clicked()"), self.exitApplication)
		self.connect(self.pushButton3, SIGNAL("clicked()"), self.run)

	def run(self):
		if self.tabWidget.currentIndex() == 0:
			if self.lineEdit1.text():
				self.findSubdomains()
		elif self.tabWidget.currentIndex() == 1:
			if self.lineEdit3.text():
				self.findEmails()
		elif self.tabWidget.currentIndex() == 2:
			if self.lineEdit4.text():
				self.findHumanRelationships()
		elif self.tabWidget.currentIndex() == 3:
			if self.lineEdit5.text():
				self.zoneTransfer()

	def xfnReference(self):
		xfnDialog = QDialog(self)
		xfnDialog.setWindowTitle("XFN quick reference")

		button = QDialogButtonBox(QDialogButtonBox.Ok)

		pixmap = QPixmap(":/xfn.png")

		label = QLabel()
		label.setPixmap(pixmap)
		label.setAlignment(Qt.AlignCenter)

		mainLayout = QVBoxLayout()
		mainLayout.addWidget(label)
		mainLayout.addWidget(button)
		xfnDialog.setLayout(mainLayout)

		xfnDialog.connect(button, SIGNAL("accepted()"), SLOT("accept()"))

		xfnDialog.exec_()

	def about(self):
		aboutDialog = QDialog(self)
		aboutDialog.setWindowTitle("About")
		aboutDialog.resize(400, 260)

		button = QDialogButtonBox(QDialogButtonBox.Ok)

		pixmap = QPixmap(":/logo.png")

		textEdit = QTextEdit()
		textEdit.setReadOnly(True)
		textEdit.setText(license)

		label1 = QLabel()
		label1.setPixmap(pixmap)
		label1.setAlignment(Qt.AlignCenter)
		label2 = QLabel(QString.fromUtf8(info))
		label2.setAlignment(Qt.AlignCenter)

		tabWidget = QTabWidget()
		tab1 = QWidget()
		tabWidget.addTab(tab1, "Program")
		tab2 = QWidget()
		tabWidget.addTab(tab2, "License")

		vBoxLayout1 = QVBoxLayout()
		vBoxLayout1.addWidget(label1)
		vBoxLayout1.addWidget(label2)
		tab1.setLayout(vBoxLayout1)

		vBoxLayout2 = QVBoxLayout()
		vBoxLayout2.addWidget(textEdit)
		tab2.setLayout(vBoxLayout2)

		mainLayout = QVBoxLayout()
		mainLayout.addWidget(tabWidget)
		mainLayout.addWidget(button)
		aboutDialog.setLayout(mainLayout)

		aboutDialog.connect(button, SIGNAL("accepted()"), SLOT("accept()"))

		aboutDialog.exec_()

	def readSettings(self):
		settings = QSettings("quickrecon", "settings")
		position = settings.value("position", QPoint(200, 200))
		self.move(position)

	def writeSettings(self):
		settings = QSettings("quickrecon", "settings")
		settings.setValue("position", self.pos())

	def selectFile(self):
		fileName = QFileDialog.getOpenFileName(self, "Select file")
		if fileName:
			self.lineEdit2.clear()
			self.lineEdit2.setText(fileName)

	def saveAs(self):
		fileName = QFileDialog.getSaveFileName(self, "Save as")
		if fileName:
			file = QFile(fileName)
			if not file.open(QFile.WriteOnly | QFile.Text):
				QMessageBox.warning(self, "Error",
									"Cannot write file %s.\n%s." % (fileName, file.errorString()))
				return

			stream = QTextStream(file)
			stream.setCodec("utf8")
			stream << self.textEdit.toPlainText()
			file.close()

	def checkHost(self, hostname):
		try:
			ip = socket.gethostbyname(hostname)
			self.buffer.write(hostname + " :  " + ip + "\n")
		except:
			pass

	def testWildcard(self):
		results = []
		charset = "abcdefghijklmnopqrstuvwxyz0123456789"
		for count in range(3):
			randomCharset = random.sample(charset, random.randint(6, 12))
			subdomain = "%s.%s" % ("".join(randomCharset), str(self.lineEdit1.text()))
			try:
				connection = httplib.HTTPConnection(subdomain)
				connection.putrequest("GET", "/")
				connection.putheader("User-Agent", random.choice(agents))
				connection.endheaders()
				response = connection.getresponse()
				results.append(response.status)
			except:
				pass

		if not results:
			return False
		else:
			return True

	def searchEngine(self):
		urls = []
		if self.checkBox1.isChecked():
			for count in range(0, self.spinBox.value(), 10):
				urls.append("http://www.google.com/search?hl=en&ie=UTF-8&num=10&q=%40" +
								str(self.lineEdit3.text()) + "&start=" + str(count))

		if self.checkBox2.isChecked():
			for count in range(0, self.spinBox.value(), 10):
				urls.append("http://groups.google.com/groups?hl=en&ie=UTF-8&num=10&q=%40" +
								str(self.lineEdit3.text()) + "&start=" + str(count))

		if self.checkBox3.isChecked():
			for count in range(1, self.spinBox.value() + 1, 10):
				urls.append("http://www.bing.com/search?q=%40" + str(self.lineEdit3.text()) +
								"&go=&count=10&first=" + str(count))

		return urls

	def findSubdomains(self):
		if self.testWildcard() is True:
			self.textEdit.setText("The target domain has a DNS wildcard configuration.")
			return
		else:
			fileName = self.lineEdit2.text()
			if fileName:
				# External dictionary
				file = QFile(fileName)
				if not file.open(QFile.ReadOnly | QFile.Text):
					QMessageBox.warning(self, "Error",
										"Cannot read file %s.\n%s." % (fileName, file.errorString()))
					return
				stream = QTextStream(file)
				while not stream.atEnd():
					line = str(stream.readLine())
					if not line.startswith("#"):
						subdomain = "%s.%s" % (line.rstrip("\n"), str(self.lineEdit1.text()))
						self.checkHost(subdomain)
			else:
				# Internal dictionary
				for item in database:
					subdomain = "%s.%s" % (item, str(self.lineEdit1.text()))
					self.checkHost(subdomain)

			if not self.buffer.getvalue():
				self.textEdit.setText("Nothing found.")
				return
			else:
				self.showOutput()

	def findEmails(self):
		results = {}
		urls = self.searchEngine()
		patterns = [re.compile(s) for s in [
											"[\w.]*" + "@<b>" + str(self.lineEdit3.text()),
											"[\w.]*" + "@<em>" + str(self.lineEdit3.text()),
											"[\w.]*" + "@<strong>" + str(self.lineEdit3.text())
											]
						]
		for url in urls:
			try:
				request = urllib2.Request(url)
				request.add_header("User-agent", random.choice(agents))
				response = urllib2.urlopen(request)
				data = response.read()
				for pattern in patterns:
					emails = re.findall(pattern, data)
					for email in emails:
						cleanEmail = re.sub("<b>|<em>|<strong>", "", email)
						results[cleanEmail] = 1
			except IOError:
				pass
			except httplib.IncompleteRead:
				QMessageBox.warning(self, "Error", "Error while reading data. Try again.")
				return

		for key in results.keys():
			self.buffer.write(key + "\n")

		if not results:
			self.textEdit.setText("Nothing found.")
			return
		else:
			self.showOutput()

	def findHumanRelationships(self):
		import HTMLParser
		try:
			from BeautifulSoup import BeautifulSoup
		except ImportError:
			QMessageBox.warning(self, "Error",
								"Please install \'BeautifulSoup\' from http://www.crummy.com/software/BeautifulSoup/.")
			return

		results = {}
		try:
			response = urllib2.urlopen(str(self.lineEdit4.text()))
		except:
			QMessageBox.warning(self, "Error", "Connection problem. Try again.")
			return

		try:
			rawData = BeautifulSoup(response)
		except HTMLParser.HTMLParseError:
			QMessageBox.warning(self, "Error", "Error while reading data. Try again.")
			return

		data = rawData.findAll("a")
		for item in data:
			for value in xfn:
				if item.has_key("rel") and re.search(value, item["rel"]) is not None:
					results[item.string] = item["href"], item["rel"]

		for key, values in results.items():
			self.buffer.write("NAME :  " + key + "\n")
			self.buffer.write("URL :  " + values[0] + "\n")
			self.buffer.write("RELATIONSHIP :  " + re.sub(" ", ", ", values[1]) + "\n\n")

		if not results:
			self.textEdit.setText("Nothing found.")
			return
		else:
			self.showOutput()

	def zoneTransfer(self):
		try:
			import dns.resolver
			import dns.query
			import dns.zone
		except ImportError:
			QMessageBox.warning(self, "Error", "Please install \'dnspython\' from http://www.dnspython.org/.")
			return

		results = []
		NS = []
		try:
			servers = dns.resolver.query(str(self.lineEdit5.text()), "NS")
		except dns.resolver.NXDOMAIN:
			QMessageBox.warning(self, "Error", "Non-Existent Domain response.")
			return

		for server in servers:
			NS.append(str(server))

		for target in NS:
			try:
				zoneTransfer = dns.zone.from_xfr(dns.query.xfr(target.rstrip("."), str(self.lineEdit5.text())))
				names = zoneTransfer.nodes.keys()
				names.sort()
				for name in names:
					results.append(zoneTransfer[name].to_text(name))
					self.buffer.write(re.sub(" ", "   ", zoneTransfer[name].to_text(name)) + "\n")
			except:
				pass

		if not results:
			self.textEdit.setText("Zone transfer is not possible.")
			return
		else:
			self.showOutput()

	def showOutput(self):
		self.textEdit.setText(self.buffer.getvalue())
		self.buffer.truncate(0)
		self.buffer.seek(0)

	def exitApplication(self):
		self.writeSettings()
		self.close()


if __name__ == "__main__":
	application = QApplication(sys.argv)
	mainWindow = QuickRecon()
	mainWindow.show()
	sys.exit(application.exec_())
